local menu = {}

local tex = {}
local timer = 0

local state = "rest"


-- TODO don't do this
local players = {
	{name = "mario"},
	{name = "princess"},
	{name = "bowser"},
	{name = "koopa"},
	{name = "luigi"},
	{name = "yoshi"},
	{name = "dkjr"},
	{name = "toad"},
}
for i = 1,#players do
	players[i].tex = lg.newImage("karts/" .. players[i].name .. "/tex.png")
end
local kartquad = {}
for i =  0,21 do  kartquad[i] = lg.newQuad(i*32, 0, 32, 32, 32*22, 32) end

local cursor = 0

local settings = {
	{
		name="player1kart",
		value = 0,
		options = {"mario","princess","bowser","koopa","luigi","yoshi","dkjr","toad"}
	},
	{
		name="player2kart",
		value = 3,
		options = {"mario","princess","bowser","koopa","luigi","yoshi","dkjr","toad"}
	},
	{
		name="track",
		value = 0,
		options = {"luigi", "bowser", "first"}
	},
	{
		name="ai",
		value = 0,
		options = {0,1,2,3,4,5,6}
	},
	{
		name="players",
		value = 0,
		options = {1,2}
	},
	{
		name="splitscreen",
		value = 0,
		options = {"tall","wide"}
	},
	{
		name="resolution",
		value = 0,
		options = {
			-- NO extra spaces, but leanding zeros are OK
			-- width, height, background height, camera offset, FOV, kart scale, background scale
			{ -- Normal 16x9
				w = 384, h = 216, bg = 80,
				offset = 0.7, fov = 1.0,
				kartscale = 1.0, bgscale = 1.0
			},
			{ -- Normal 4x3
				w = 288, h = 216, bg = 80,
				offset = 0.7, fov = 1.0,
				kartscale = 1.0, bgscale = 1.0
			},
			{ -- SNES
				w = 256, h = 104, bg = 21,
				offset = 0.9, fov = 1.0,
				kartscale = 1.0, bgscale = 1.0
			},
			{ -- GBA
				w = 240, h = 160, bg = 74,
				offset = 0.8, fov = 1.25,
				kartscale = 1.0, bgscale = 1.0
			},
			{ -- 1080p (16x9)
				w = 1920, h = 1080, bg = 420,
				offset = 0.7, fov = 1.5,
				kartscale = 5.0, bgscale = 5.0
			},
			{ -- 1080p (4x3)
				w = 1440, h = 1080, bg = 420,
				offset = 0.7, fov = 1.125,
				kartscale = 5.0, bgscale = 5.0
			},
		},
		text = {"Normal (16x9)","Normal (4x3)","SNES", "GBA", "1080p (16x9)", "1080p (4x3)"},
	},
	--~ {
		--~ name="fixed_fps",
		--~ value = 0,
		--~ options = {true, false},
	--~ },
}



menu.init = function()
	for i,k in pairs(love.filesystem.getDirectoryItems("menu/tex")) do
		if k:sub(-4) == ".png" then
			tex[k:sub(1,-5)] = lg.newImage("menu/tex/" .. k)
		end
	end

	-- set some settings
	local w,h,f = love.window.getMode()
	if f.vsync == 0 or f.refreshrate > 61 or f.refreshrate < 59 then
		settings[7].value = 1
	end
end

menu.update = function(dt)
	timer = timer + dt
end

menu.draw = function()
	lg.center(256,224)
	if state == "kart" then
		lg.draw(tex.kartsel_bg, 32 - ((timer) * 60)%32      , 77)
		lg.draw(tex.kartsel_bg, 32 - ((timer) * 60)%32 +  32, 77)
		lg.draw(tex.kartsel_bg, 32 - ((timer) * 60)%32 +  64, 77)
		lg.draw(tex.kartsel_bg, 32 - ((timer) * 60)%32 +  96, 77)
		lg.draw(tex.kartsel_bg, 32 - ((timer) * 60)%32 + 128, 77)
		lg.draw(tex.kartsel_bg, 32 - ((timer) * 60)%32 + 160, 77)

		lg.draw(tex.kartsel_bg, 32 - ((timer) * 60)%32      , 141)
		lg.draw(tex.kartsel_bg, 32 - ((timer) * 60)%32 +  32, 141)
		lg.draw(tex.kartsel_bg, 32 - ((timer) * 60)%32 +  64, 141)
		lg.draw(tex.kartsel_bg, 32 - ((timer) * 60)%32 +  96, 141)
		lg.draw(tex.kartsel_bg, 32 - ((timer) * 60)%32 + 128, 141)
		lg.draw(tex.kartsel_bg, 32 - ((timer) * 60)%32 + 160, 141)

		lg.draw(tex.kartsel_fg)

		for i = 0,7 do
			lg.draw(players[i + 1].tex, kartquad[7], 42 + (i%4) * 48, 80 + floor(sin(timer * 20 + i*17) * .5) + floor(i/4)*64)
		end

		if (timer*60)%8 > 1 then
			lg.draw(tex.kartsel_p1, 50 + 48 * (cursor%4), 64 + 64 * floor(cursor/4))
		end
	elseif state == "rest" then
		lg.setColor(0.5,0.5,1.0)
		lg.rectangle("fill", 64, 16 + 16*cursor, 160, 16)
		lg.setColor(1,1,1)
		for i,j in pairs(settings) do
			lg.print(j.name, 64, 16*i)
			if j.text then
				lg.print(j.text[j.value + 1], 160, 16*i)
			else
				lg.print(tostring(j.options[j.value + 1]), 160, 16*i)
			end
		end
	end
end

function menu.press(key)
	if state == "kart" then
		if key == "right" then
			cursor = (cursor + 1) % #players
		elseif key == "left" then
			cursor = (cursor - 1) % #players
		elseif key == "return" then
			state = "rest"
			settings[1].value = cursor
			cursor = 0
		end

	elseif state == "rest" then
		if key == "up" then
			cursor = (cursor - 1) % #settings
		elseif key == "down" then
			cursor = (cursor + 1) % #settings
		elseif key == "right" then
			local s = settings[cursor + 1]
			s.value = (s.value + 1) % #s.options
		elseif key == "left" then
			local s = settings[cursor + 1]
			s.value = (s.value - 1) % #s.options
		elseif key == "return" then
			local s = {}
			for i = 1,#settings do
				s[settings[i].name] = settings[i].options[settings[i].value + 1]
			end
			return s
		end
	end
end

return menu