extern Image map;
extern float x;
extern float y;
extern float w;
extern float h;
extern float zoom;
extern float fov;
extern float offset;
extern float scale;
extern mat2 rotation;
extern vec4 fogcol;
extern bool nocenter;
vec4 effect(vec4 color, Image texture, vec2 uv, vec2 pixel_coords)
{
	vec2 uv2 = vec2(
		(uv.x - 0.5)*zoom,
		(offset - uv.y)*fov
	) * rotation;
	vec2 uv3 = vec2(
		(uv2.x / (uv.y) + x*w)/w,
		(uv2.y / (uv.y) + y*h)/h
	);
	vec4 col = texture2D(map,uv3*scale);
	if (uv3.x > 0.0 && uv3.x < 1.0 && uv3.y > 0.0 && uv3.y < 1.0 && nocenter)
		return vec4(0.0,0.0,0.0,0.0);
	else
		return vec4(mix(col.rgb, fogcol.rgb, pow(1.0 - uv.y, 5.0) * fogcol.a), col.a);
}