extern Image map;
extern float x;
extern float y;
extern float w;
extern float h;
extern float zoom;
extern float fov;
extern float offset;

extern mat2 rotation;
extern vec4 fogcol;

vec4 effect(vec4 color, Image texture, vec2 uv, vec2 pixel_coords)
{
	vec2 uv2 = vec2(
		(uv.x - 0.5)*zoom,
		(offset - uv.y)*fov
	) * rotation;
	vec2 uv3 = vec2(
		(uv2.x / (uv.y) + x*w)/w,
		(uv2.y / (uv.y) + y*h)/h
	);
	vec4 col = texture2D(map,uv3);
	return vec4(mix(col.rgb, fogcol.rgb, pow(1.0 - uv.y, 5.0) * fogcol.a), col.a);
}